import datetime as dt
import json
from pytz import timezone
from decimal import Decimal

from news.renders import extended_encoder, JSONRenderer


def test_extended_encoder_date_parsing():
    test_date = dt.datetime(2017, 5, 10, tzinfo=timezone('UTC'))
    assert test_date.timestamp() == extended_encoder(test_date)


def test_extended_encoder_decimal_casting():
    test_decimal = Decimal('1.0')
    assert 1.0 == extended_encoder(test_decimal)


def test_render_with_extended_encoder():
    test_date = dt.datetime(2017, 5, 10)
    test_decimal = Decimal('0.1')
    expected = dict(my_date=1494374400.0, my_float=0.1)
    test_response = dict(my_date=test_date, my_float=test_decimal)
    assert json.dumps(expected).encode('utf-8') == JSONRenderer().render(test_response)
